-- Speccy's Main Lua
-- Speccy - 2022

-- Don't take stuff from this Lua without getting my permission first.

-- SRB2Persona in this script? Nahhhh..

if srb2p then return end

-- Misc. variables.

local skinchanged = true

-- Console variable for the level up jingle, the one for the hud is near the end of file.

local speccy_levelupjingle = CV_RegisterVar({
	name = "speccy_levelupjingle",
	defaultvalue = 1,
	flags = nil,
	PossibleValue = CV_OnOff,
	func = nil
})

-- Leveling function, pretty nice. It's from Disgea by the way... just with some edits.

rawset(_G, "newExpRequirement", function(p)
	return FixedRound((2621/12) * ((p.speccy.level+1) ^ 3) + (52428/12) * ((p.speccy.level+1) ^ 2) + (131070/12) * (p.speccy.level+1))/(65535/12)
end)

rawset(_G, "levelSpeccyUp", function(p)
	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" and p.speccy then
			if p.speccy.level >= 200 then
				p.speccy.exp = p.speccy.expreq
				return
			end
		
			if speccy_levelupjingle.value then
				S_StartSound(p.mo, sfx_lvup, p)
			end
			p.speccy.level = $ + 1
			p.speccy.totalexp = $ + p.speccy.exp
			p.speccy.exp = $ - p.speccy.expreq
			p.speccy.expreq = newExpRequirement(p)
			p.speccy.maxhp = $ + (p.speccy.maxhp % (p.speccy.level+5)%p.speccy.maxhp)
			p.speccy.hp = p.speccy.maxhp
			if not (p.speccy.level % 5) then
				if not p.speccy.newnormalspeed then
					p.speccy.newnormalspeed = skins["speccy"].normalspeed
				end
				p.speccy.newnormalspeed = $ + (p.speccy.level%2)*FRACUNIT
			end
			if p.speccy.level == 30 then
				p.speccy.crouchtip = 1
				p.speccy.crouchtipdisplay = 3*TICRATE
			end
			
			if p.speccy.exp < 0 then
				p.speccy.exp = 0
			end
		else
			error("cannot level up if you're not Speccy!", 2)
		end
	else
		error("cannot level up if you don't exist!", 2)
	end
end)

/*COM_AddCommand("levelup", function(p, arg)
	if tonumber(arg) ~= nil then
		arg = tonumber(arg)
	else
		arg = 1
	end
	
	for i=1,tonumber(arg) do
		levelSpeccyUp(p)
	end
end)*/

-- Boss Table, supports custom bosses by adding them after Speccy... maybe you can add them before, I don't know, maybe by rawsetting it yourself.
-- This is carried over from before the re-script.

-- Layout: [MT_MOBJNAME] = {"Boss Name", Damage, EXP reward}

rawset(_G, "adventureBossTable", {
	[MT_EGGMOBILE] = {"Egg Zapper", 25, 75},
	[MT_EGGMOBILE2] = {"Egg Slimer", 35, 150},
	[MT_EGGMOBILE3] = {"Sea Egg", 45, 175},
	[MT_EGGMOBILE4] = {"Egg Colosseum", 50, 250},
	[MT_FANG] = {"Fang the Sniper", 35, 500},
	[MT_METALSONIC_BATTLE] = {"Metal Sonic", 50, 750},
	[MT_CYBRAKDEMON] = {"Black Eggman", 100, 1000},
})

rawset(_G, "adventureInfTable", {
	[MT_CORK] = 25,
	[MT_CYBRAKDEMON_MISSILE] = 50,
	[MT_BLACKEGGMAN_MISSILE] = 50,
	[MT_CYBRAKDEMON_VILE_EXPLOSION] = 75,
	[MT_CYBRAKDEMON_FLAMESHOT] = 25,
	[MT_CYBRAKDEMON_FLAMEREST] = 25,
	[MT_CYBRAKDEMON_NAPALM_FLAMES] = 25,
	[MT_FBOMB] = 40,
	[MT_LASER] = 35,
	[MT_EGGMOBILE_BALL] = 25,
	[MT_EGGMOBILE_FIRE] = 25,
	[MT_TORPEDO] = 35,
	[MT_ENERGYBALL] = 45,
	[MT_TURRETLASER] = 15,
	[MT_SHOCKWAVE] = 35,
	[MT_EGGMOBILE4_MACE] = 45,
	[MT_GOOP] = 15,
	[MT_JETTBULLET] = 25,
	[MT_MINE] = 35,
	[MT_CYBRAKDEMON_ELECTRIC_BARRIER] = 100,
})

rawset(_G, "adventureEXPTable", {
	[MT_RING] = 1,
	[MT_FLINGRING] = 1,
	[MT_BLUESPHERE] = 5,
	[MT_TOKEN] = 100,
	[MT_RING_BOX] = 10,
	[MT_1UP_BOX] = 50,
	[MT_EGGMAN_BOX] = -25,
})

rawset(_G, "adventureHealTable", {
	[MT_RING] = 1,
	[MT_RING_BOX] = 10,
	[MT_1UP_BOX] = 50,
	[MT_BLUESPHERE] = 5,
	[MT_TOKEN] = 100
})

rawset(_G, "resetSpeccyVars", function(p)
	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" then
			p.speccy = {}
			p.speccy.maxhp = 100
			p.speccy.hp = p.speccy.maxhp
			p.speccy.level = 1
			p.speccy.exp = 0
			p.speccy.expreq = newExpRequirement(p)
			p.speccy.totalexp = 0
			p.speccy.multiplier = FRACUNIT
			p.speccy.crouchtype = 1
			p.speccy.supertime = 30*TICRATE
		else
			error("cannot run resetSpeccyVars if you're not Speccy!", 2)
		end
	else
		error("cannot run resetSpeccyVars if you don't exist!", 2)
	end
end)

rawset(_G, "shouldSpeccyCrouch", function(p, arg)

	if G_IsSpecialStage(gamemap) then return end

	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" then
		
			if arg then
				return true
			else
				if p.speccy.crouchtype == 1 then
					if (p.cmd.buttons & BT_CUSTOM1) then
						return true
					else
						return false
					end
				elseif p.speccy.shouldcrouch then
					return true
				else
					return false
				end
			end
		else
			return false
		end
	else
		return false
	end
end)

COM_AddCommand("speccy_crouchtype", function(p, arg)
	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" and p.speccy then
			if tonumber(arg) ~= nil then
			
				arg = tonumber(arg)
			
				if arg > 0 and arg <= 2 then
					p.speccy.crouchtype = arg
				else
					CONS_Printf(p, "Invalid crouch type.")
				end
			else
				CONS_Printf(p, "\nspeccy_crouchtype:\n\n- Usage: speccy_crouchtype <number>\n\nTypes:\n\n- 1: Hold to crouch.\n- 2: Tap to crouch.\n")
			end
		end
	end
end)

addHook("PlayerThink", function(p)

	if G_IsSpecialStage(gamemap) then return end

	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" then
			if p.speccy == nil then
				resetSpeccyVars(p)
			else

				p.speccy.multiplier = FRACUNIT + (((p.speccy.level*FRACUNIT)/10)+((p.scoreadd*FRACUNIT)/100) + ((emeralds*FRACUNIT)/50)*2)
			
				if p.powers[pw_super] then
					p.speccy.multiplier = $ + FRACUNIT
					if p.speccy.hp < p.speccy.maxhp then
						p.speccy.hp = $ + p.speccy.maxhp/100
					else
						p.speccy.hp = p.speccy.maxhp
					end
					p.rings = 50
					p.speccy.supertime = $-1
					if (p.speccy.supertime <= 0) or ((p.cmd.buttons & BT_CUSTOM1) and (p.pflags & PF_JUMPED)) then
						p.powers[pw_super] = 0
						if p.speccy.newnormalspeed then
							p.normalspeed = p.speccy.newnormalspeed
						else
							p.normalspeed = skins["speccy"].normalspeed
						end
						p.jumpfactor = skins["speccy"].jumpfactor
						p.mo.color = p.skincolor
						COM_BufInsertText(p, "tunes -default")
					end
				end
				
				if emeralds == 127 then
					p.rings = 50
				end
			
				if p.speccy.exp >= p.speccy.expreq then
					levelSpeccyUp(p)
				end
				
				if p.speccy.level >= 200 and p.speccy.exp >= p.speccy.expreq then
					if not (p.speccy.shades and p.speccy.shades.valid) then
						p.speccy.shades = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SHADES)
					else
						if not (p.mo.flags2 & MF2_OBJECTFLIP) then
							p.speccy.shades.flags2 = $ & ~MF2_OBJECTFLIP
							P_TeleportMove(p.speccy.shades, p.mo.x + p.mo.momx + FixedMul(1*FRACUNIT, cos(p.drawangle)), p.mo.y + p.mo.momy + FixedMul(8*FRACUNIT, sin(p.drawangle)), p.mo.z + p.mo.momz)
						else
							p.speccy.shades.flags2 = $|MF2_OBJECTFLIP
							P_TeleportMove(p.speccy.shades, p.mo.x + p.mo.momx + FixedMul(1*FRACUNIT, cos(p.drawangle)), p.mo.y + p.mo.momy + FixedMul(8*FRACUNIT, sin(p.drawangle)), p.mo.z + p.mo.momz - p.mo.height)
						end
						if camera.chase then
							p.speccy.shades.flags2 = $ & ~MF2_DONTDRAW
						else
							p.speccy.shades.flags2 = $|MF2_DONTDRAW
						end
						p.speccy.shades.momz = 0
						p.speccy.shades.angle = p.drawangle
						p.speccy.shades.scale = FRACUNIT/2
					end
				elseif (p.speccy.shades and p.speccy.shades.valid) then
					P_RemoveMobj(p.speccy.shades)
				end
				
				if p.playerstate == PST_REBORN and p.speccy.hp < p.speccy.maxhp / 2 then
					p.speccy.hp = p.speccy.maxhp / 2
				end
				
				if P_IsObjectOnGround(p.mo) then
				
					if p.speccy.crouchtype == 2 then
					
						if not (p.cmd.buttons & BT_CUSTOM1) then
							p.speccy.crouchready = true
							p.speccy.crouchtap = false
						elseif p.speccy.crouchready then
							p.speccy.crouchready = false
							p.speccy.crouchtap = true
						else
							p.speccy.crouchtap = false
						end
					
						if p.speccy.crouchtap then
							if p.speccy.shouldcrouch then
								p.speccy.shouldcrouch = false
							else
								p.speccy.shouldcrouch = true
							end
						end
					
					end
				
					if shouldSpeccyCrouch(p, false) then
						p.speccy.crouch = true
						p.pflags = $|PF_JUMPSTASIS
						p.mo.state = S_PLAY_SPECCROUCH
						p.normalspeed = 4*FRACUNIT
					else
						if p.speccy.crouch then
							p.speccy.crouch = false
							p.mo.state = S_PLAY_STND
							p.pflags = $ & ~PF_JUMPSTASIS
							p.normalspeed = skins[p.mo.skin].normalspeed
						end
					end
				else
					if p.speccy.crouch then
						p.speccy.crouch = false
						p.mo.state = S_PLAY_FALL
						p.pflags = $ & ~PF_JUMPED
						p.pflags = $ & ~PF_JUMPSTASIS
						p.normalspeed = skins[p.mo.skin].normalspeed
					end
				end
				
				for s in mobjs.iterate() do
					if s.type == MT_METROID then
						if s.latchsuck and (s.latchtarget and s.latchtarget.valid) then
							if s.latchtarget.player == p and p.speccy.hp > 1 then
								if p.speccy.crouch and p.speccy.level >= 30 then
									s.latchsuck = 0
									s.stuntroid = 120
									s.actiontroid = P_RandomRange(37, 65)
									s.latchtarget = nil
									for d = 1,18
										if (P_TryMove(s, s.x+FixedMul(-50*FRACUNIT, cos(ANG20*d)), s.y+FixedMul(-50*FRACUNIT, sin (ANG20*d)), false))
											return
										end
									end
								end
								s.survivemetroid = 2
								if (not p.powers[pw_flashing]) and (not p.speccy.crouch) then
									p.speccy.hp = $ - FixedRound(p.speccy.level/2*FRACUNIT)/FRACUNIT
									p.powers[pw_flashing] = 5
								end
								if p.mo.state == S_PLAY_MELEE then
									s.momz = 2*FRACUNIT s.momx = p.mo.momx*-1 s.momy = p.mo.momy*-1
									S_StartSound(s, sfx_mtrd2)
									s.stuntroid = 120
									s.latchsuck = 0
									s.actiontroid = P_RandomRange(37, 65)
									P_SamFP(p, PAL_RECYCLE, 3)
									s.latchtarget = nil
									for d = 1,18
										if (P_TryMove(s, s.x+FixedMul(-50*FRACUNIT, cos(ANG20*d)), s.y+FixedMul(-50*FRACUNIT, sin (ANG20*d)), false))
											return
										end
									end
								end
							elseif p.speccy.hp < 1 then
								P_DamageMobj(p.mo, s, s, 1, DMG_INSTAKILL)
							end
						end
					end
				end
				
				if p.speccy.hp < 0 then
					p.speccy.hp = 0
				elseif p.speccy.hp > p.speccy.maxhp and not (p.speccy.shades and p.speccy.shades.valid) then
					p.speccy.hp = p.speccy.maxhp
				elseif p.speccy.hp > p.speccy.maxhp + p.speccy.maxhp/2 and (p.speccy.shades and p.speccy.shades.valid) then
					p.speccy.hp = p.speccy.maxhp + p.speccy.maxhp/2
				end
				
				if leveltime <= 0 then
					if p.speccy.shades and p.speccy.shades.valid and p.speccy.hp <= p.speccy.maxhp then
						local bossexists = false
						for mobj in mobjs.iterate() do
							if mobj.flags & MF_BOSS then
								bossexists = true
							end
						end
						if bossexists then
							p.speccy.hp = $ + p.speccy.maxhp/2
						end
					end
				end
				
				if p.speccy.newnormalspeed then
					p.normalspeed = p.speccy.newnormalspeed
				end
				
			end
		end
		
		if p.lastskin == "speccy" and p.mo.skin ~= "speccy" then
			skinchanged = true
		end
		
		p.lastskin = p.mo.skin
		
	end
end)

addHook("AbilitySpecial", function(p)
	if p.mo.skin ~= "speccy" then return end

	if not (p.pflags & PF_THOKKED) then
		P_SetObjectMomZ(p.mo, (10*p.jumpfactor), false)
		for i=1,8 do
			P_SpawnSkidDust(p, p.mo.radius, false)
		end
		S_StartSound(p.mo, sfx_cdfm02)
		p.mo.state = S_PLAY_JUMP
		p.pflags = $|PF_THOKKED
	end
end)

-- Crouching makes Speccy take less space, so make it true for the game too.

local function CrouchHeight(p)

	if G_IsSpecialStage(gamemap) then return end

	if not (p.mo and p.mo.valid) then 
		return false
	end

	if p.speccy and p.mo.skin == "speccy" then
		if p.speccy.crouch then
			return 24*FRACUNIT
		elseif (p.pflags & PF_SPINNING) then
			return 24*FRACUNIT
		else
			return 42*FRACUNIT
		end
	end
end

local function CrouchGap(p)

	if G_IsSpecialStage(gamemap) then return end

	if not (p.mo and p.mo.valid) then 
		return false
	end

	if p.speccy and p.mo.skin == "speccy" then
		if p.speccy.crouch then
			return true
		end
	end
end

addHook("PlayerHeight", CrouchHeight)
addHook("PlayerCanEnterSpinGaps", CrouchGap)

-- Damage Handler

addHook("ShouldDamage", function(pmo, inf, src, dmg, dmgtype)

	if G_IsSpecialStage(gamemap) then return end

	if pmo and pmo.valid then
		if pmo.skin == "speccy" then
		
			if pmo.player then
				if (pmo.player.pflags & PF_GODMODE) then return false end
			end
		
			if dmgtype == DMG_INSTAKILL or dmgtype == DMG_CRUSHED or dmgtype == DMG_DROWNED or dmgtype == DMG_DEATHPIT then return true end
		
			if pmo.player then
				local p = pmo.player
				
				if p.powers[pw_flashing] or p.powers[pw_invulnerability] or p.powers[pw_super] then
					return false
				elseif p.powers[pw_shield] ~= SH_NONE then
					return true
				end
				
				if inf and inf.valid then
					if src and src.valid then
						if inf == src then
							if (src.flags & MF_BOSS) then
								if adventureBossTable[src.type] ~= nil then
									p.speccy.hp = $ - adventureBossTable[src.type][2]
								else
									p.speccy.hp = $ - 25
								end
								
								P_DoPlayerPain(p, src, inf)
								p.powers[pw_flashing] = 2*TICRATE
							elseif (src.flags & MF_ENEMY) then
								p.speccy.hp = $ - P_RandomRange(5,10)
								P_DoPlayerPain(p, src, inf)
								p.powers[pw_flashing] = 2*TICRATE
							else
								if adventureInfTable[inf.type] ~= nil then
									p.speccy.hp = $ - adventureInfTable[inf.type]
								else
									p.speccy.hp = $ - P_RandomRange(10,15)
								end
								P_DoPlayerPain(p, src, inf)
								p.powers[pw_flashing] = 2*TICRATE
							end
						else
							if adventureInfTable[inf.type] ~= nil then
								p.speccy.hp = $ - adventureInfTable[inf.type]
							else
								p.speccy.hp = $ - P_RandomRange(10,15)
							end
							P_DoPlayerPain(p, src, inf)
							p.powers[pw_flashing] = 2*TICRATE
						end
					else
						if adventureInfTable[inf.type] ~= nil then
							p.speccy.hp = $ - adventureInfTable[inf.type]
						else
							p.speccy.hp = $ - P_RandomRange(10,15)
						end
						P_DoPlayerPain(p, src, inf)
						p.powers[pw_flashing] = 2*TICRATE
					end
					
					if p.speccy.hp <= 0 then
						p.speccy.hp = 0
						P_DamageMobj(pmo, inf, src, dmg, DMG_INSTAKILL)
					end
					
					return false
					
				end
				
				if dmgtype == DMG_SPIKE then
					p.speccy.hp = $ - 25
					P_DoPlayerPain(p, src, inf)
					p.powers[pw_flashing] = 3*TICRATE
				elseif dmgtype == DMG_FIRE then
					p.speccy.hp = $ - P_RandomRange(1, 2)
					p.powers[pw_flashing] = P_RandomRange(1, 2)
				elseif dmgtype == DMG_ELECTRIC then
					p.speccy.hp = $ - P_RandomRange(5, 10)
					p.powers[pw_flashing] = P_RandomRange(5, 10)
					if P_RandomRange(1, 2) == 2 then
						P_InstaThrust(pmo, p.drawangle, 0)
					end
				elseif dmgtype == DMG_WATER then
					p.speccy.hp = $ - P_RandomRange(1, 2)
					p.powers[pw_flashing] = P_RandomRange(2, 5)
				elseif dmgtype == DMG_NUKE then
					p.speccy.hp = $ - 50
					p.powers[pw_flashing] = 3*TICRATE
				end
				
				if p.speccy.hp <= 0 then
					p.speccy.hp = 0
					P_DamageMobj(pmo, inf, src, dmg, DMG_INSTAKILL)
				end
				
				return false
				
			end
		end
	end
end)

-- Enemy Handler

addHook("ShouldDamage", function(mo, inf, src, dmg, dmgtype)
	if src and src.valid then
		if src.player and src.skin == "speccy" then
			if mo and mo.valid then
				if (mo.flags & MF_ENEMY) or (mo.flags & MF_BOSS) then
				
					if dmgtype == DMG_NUKE then
						return true
					end
				
					if (mo.flags & MF_BOSS) and (mo.flags2 & MF2_FRET) then
						return false
					end
				
					if (mo.flags & MF_BOSS) then
						P_InstaThrust(src, src.angle, -4*FRACUNIT)
					end
	
				end
			end
		end
	end
end)

-- EXP Handler

addHook("MobjDeath", function(mo, inf, pmo)
	if pmo and pmo.valid then
		if pmo.player and pmo.player.speccy and pmo.skin == "speccy" then
			if (mo.flags & MF_BOSS) then
				if adventureBossTable[mo.type] ~= nil then
					pmo.player.speccy.exp = $ + adventureBossTable[mo.type][3]*pmo.player.speccy.multiplier/FRACUNIT
				else
					pmo.player.speccy.exp = $ + 25*pmo.player.speccy.multiplier/FRACUNIT
				end
			elseif (mo.flags & MF_ENEMY) then
				pmo.player.speccy.exp = $ + P_RandomRange(9,12)*pmo.player.speccy.multiplier/FRACUNIT
				if pmo.player.powers[pw_super] then
					pmo.player.speccy.supertime = $ + 17
				elseif emeralds == 127 then
					pmo.player.speccy.supertime = $ + 35
				end
			end
		end
	end
end)

addHook("MobjDeath", function(mo, inf, pmo)
	if pmo and pmo.valid then
		if pmo.player and pmo.player.speccy and pmo.skin == "speccy" then
			if adventureEXPTable[mo.type] ~= nil then
				pmo.player.speccy.exp = $ + adventureEXPTable[mo.type]*pmo.player.speccy.multiplier/FRACUNIT
			elseif (mo.flags & MF_MONITOR) then
				pmo.player.speccy.exp = $ + 10*pmo.player.speccy.multiplier/FRACUNIT
			end
			
			if adventureHealTable[mo.type] ~= nil then
				for i=1,adventureHealTable[mo.type] do
					if pmo.player.speccy.hp < pmo.player.speccy.maxhp then
						pmo.player.speccy.hp = $ + 1
					end
				end
			end
		end
	end
end)

-- HUD stuff at the very bottom.
-- Seeing as people are going to be reading this maybe, I'll post on how to make a HUD.

-- In order to make a HUD, start with checking for the below:

if not speccyCustomHud then
  rawset(_G, "speccyCustomHud", {})
end

-- Starting with the actual HUD here.
-- You'll be wanting to read a lot of Speccy's stats here so I made a list for you!

    -- p.speccy    - This is your main array, always check for this after making sure the player exists.
    -- p.speccy.hp - Your health.
    -- p.speccy.maxhp - Your maximum health.
    -- p.speccy.level - Your level.
    -- p.speccy.exp   - Your current EXP count. 
    -- p.speccy.expreq   - EXP needed to reach next level. p.exqreq - p.exp to get EXP left.
    -- p.speccy.totalexp - Total EXP gained throughout the play session. It only updates when you level up. 
    -- p.speccy.supertime - How many tics you have left before you transform out of your Super form.
	-- So for a Total EXP counter do p.speccy.exp + p.speccy.totalexp

-- HUD function here.

--speccyCustomHud[#speccyCustomHud+1] = function(v, p)

    -- HUD Code here.
    
--end

-- What is MGR!? FIRST THE MUSIC, NOW THE HUD!?

speccyCustomHud[#speccyCustomHud+1] = function(v, p)

	-- RAIDEN? JACK? NAH MORE LIKE SPECCY!

	if p.powers[pw_super] then
		v.drawString(24, 17, "SPECCY", nil, "thin")
		v.drawString(24+v.stringWidth("SPECCY", nil, "thin")+2, 18, "- \x85SUPER\x80: "..tostring(p.speccy.supertime/TICRATE), nil, "small")
	elseif emeralds == 127 then
		v.drawString(24, 17, "SPECCY", nil, "thin")
		v.drawString(24+v.stringWidth("SPECCY", nil, "thin")+2, 18, "- \x86SUPER\x80: "..tostring(p.speccy.supertime/TICRATE), nil, "small")
	else
		v.drawString(24, 17, "SPECCY", nil, "thin")
	end
	
	-- HP Bar & Percentage
	
	local percentageincrease = 0
	
	if p.speccy.level >= 100 then
		percentageincrease = p.speccy.level - 100
	end
	
	if not p.powers[pw_super] then
		if p.speccy.hp > p.speccy.maxhp and p.speccy.shades then
			v.drawFill(24, 26, 108, 1, 59)
			v.drawFill(24, 27, 108, 1, 55)
			v.drawFill(24, 28, 108, 1, 57)
			v.drawString(24+108, 16, tostring(((100+percentageincrease)*p.speccy.hp/p.speccy.maxhp*(100+percentageincrease))/(100+percentageincrease)).."%", V_REDMAP, "right")
			v.drawFill(132, 26, (108*p.speccy.hp/p.speccy.maxhp*108)/(206+54*4), 1, 39)
			v.drawFill(132, 27, (108*p.speccy.hp/p.speccy.maxhp*108)/(206+54*4), 1, 35)
			v.drawFill(132, 28, (108*p.speccy.hp/p.speccy.maxhp*108)/(206+54*4), 1, 37)
			v.drawFill(24, 26, 108, 1, 55)
			v.drawFill(24, 27, 108, 1, 51)
			v.drawFill(24, 28, 108, 1, 53)
		else
			v.drawFill(24, 26, 108, 1, 59)
			v.drawFill(24, 27, 108, 1, 55)
			v.drawFill(24, 28, 108, 1, 57)
			v.drawString(24+108, 16, tostring(((100+percentageincrease)*p.speccy.hp/p.speccy.maxhp*(100+percentageincrease))/(100+percentageincrease)).."%", V_ORANGEMAP, "right")
			v.drawFill(24, 26, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, 55)
			v.drawFill(24, 27, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, 51)
			v.drawFill(24, 28, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, 53)
		end
	else
		v.drawFill(24, 26, 108, 1, skincolors[p.mo.color].ramp[15])
		v.drawFill(24, 27, 108, 1, skincolors[p.mo.color].ramp[7])
		v.drawFill(24, 28, 108, 1, skincolors[p.mo.color].ramp[11])
		v.drawString(24+108, 16, tostring(((100+percentageincrease)*p.speccy.hp/p.speccy.maxhp*(100+percentageincrease))/(100+percentageincrease)).."%", skincolors[p.mo.color].chatcolor, "right")
		v.drawFill(24, 26, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, skincolors[p.mo.color].ramp[7])
		v.drawFill(24, 27, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, skincolors[p.mo.color].ramp[0])
		v.drawFill(24, 28, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, skincolors[p.mo.color].ramp[3])
	end
	
	-- EXP Bar... replaces your FC I guess.
	
	v.drawFill(24, 30, 96, 1, 139)
	v.drawFill(24, 31, 96, 1, 135)
	v.drawFill(24, 32, 96, 1, 137)
	v.drawFill(24, 33, 96, 1, 135)
	v.drawFill(24, 34, 96, 1, 137)
	
	if p.speccy.level >= 200 and p.speccy.exp >= p.speccy.expreq then
		v.drawFill(24, 30, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 39)
		v.drawFill(24, 31, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 35)
		v.drawFill(24, 32, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 37)
		v.drawFill(24, 33, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 35)
		v.drawFill(24, 34, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 37)
	else
		if p.speccy.exp >= p.speccy.expreq then
			v.drawFill(24, 30, 96, 1, 135)
			v.drawFill(24, 31, 96, 1, 131)
			v.drawFill(24, 32, 96, 1, 133)
			v.drawFill(24, 33, 96, 1, 131)
			v.drawFill(24, 34, 96, 1, 133)
		else
			v.drawFill(24, 30, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 135)
			v.drawFill(24, 31, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 131)
			v.drawFill(24, 32, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 133)
			v.drawFill(24, 33, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 131)
			v.drawFill(24, 34, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 133)
		end
	end
	
	-- Lets put EXP values under it too.

	if p.speccy.level >= 200 and p.speccy.exp >= p.speccy.expreq then
		v.drawString(24, 36, ">EXP: "..tostring(p.speccy.exp).."/"..tostring(p.speccy.expreq), V_REDMAP, "thin")
	else
		v.drawString(24, 36, ">EXP: "..tostring(p.speccy.exp).."/"..tostring(p.speccy.expreq), V_SKYMAP, "thin")
	end
	
	-- And our Level under that-

	v.drawString(24, 44, ">LV: "..tostring(p.speccy.level), V_SKYMAP, "thin")
	
	-- And our lives under that...
	
	v.drawFill(24, 52, 8, 8, 53)
	v.drawString(24, 51, "+  ")
	v.drawString(34, 53, p.lives, nil, "thin")

	-- What about Bosses? Eh.. fine.

	if (not (p.speccy.boss and p.speccy.boss.valid)) or p.speccy.boss.health <= 0 then
		for mobj in mobjs.iterate() do
			if (mobj.flags & MF_BOSS) and R_PointToDist2(p.mo.x, p.mo.y, mobj.x, mobj.y) < 2048*FRACUNIT and mobj.health > 0 then
				p.speccy.boss = mobj
			end
		end
	else
	
		if adventureBossTable[p.speccy.boss.type] ~= nil then
			v.drawString(320-132, 200-36, adventureBossTable[p.speccy.boss.type][1], nil, "thin")
		else
			v.drawString(320-132, 200-36, "BOSS", nil, "thin")
		end
		
		if (p.speccy.boss.type == MT_METROIDBOSS) then
			p.speccy.boss = p.speccy.boss.hitbox
		end
		
		if (p.speccy.boss.type == MT_CYBRAKDEMON) or (p.speccy.boss.type == MT_EGGANIMUS) then
			if p.speccy.boss.type == MT_EGGANIMUS then
				v.drawString(320-24, 200-37, tostring(100+(100*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*100)/100).."%", V_ORANGEMAP, "right")
			else
				if p.speccy.boss.superbrak then
					v.drawString(320-24, 200-37, tostring((100*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*100)/46).."%", V_REDMAP, "right")
				else
					v.drawString(320-24, 200-37, tostring((100*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*100)/50).."%", V_ORANGEMAP, "right")
				end
			end
		else
			v.drawString(320-24, 200-37, tostring((100*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*100)/100).."%", V_ORANGEMAP, "right")
		end
		
		v.drawFill(320-132, 200-28, 108, 1, 133) 
		if p.speccy.boss.superbrak then
			v.drawFill(320-132, 200-25, 108, 1, 43)
			v.drawFill(320-132, 200-24, 108, 1, 39)
			v.drawFill(320-132, 200-23, 108, 1, 41)
		else
			v.drawFill(320-132, 200-25, 108, 1, 59)
			v.drawFill(320-132, 200-24, 108, 1, 55)
			v.drawFill(320-132, 200-23, 108, 1, 57)
		end
		if (p.speccy.boss.type == MT_EGGANIMUS_EX) then
			v.drawFill(320-132, 200-25, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 55)
			v.drawFill(320-132, 200-24, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 51)
			v.drawFill(320-132, 200-23, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 53)
		elseif (p.speccy.boss.type == MT_EGGANIMUS) then
			v.drawFill(320-132, 200-25, 54, 1, 55)
			v.drawFill(320-132, 200-24, 54, 1, 51)
			v.drawFill(320-132, 200-23, 54, 1, 53)
			v.drawFill(320-132+54, 200-25, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 55)
			v.drawFill(320-132+54, 200-24, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 51)
			v.drawFill(320-132+54, 200-23, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 53)
		else
			if p.speccy.boss.superbrak then
				v.drawFill(320-132, 200-25, (54/2*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108-18, 1, 39)
				v.drawFill(320-132, 200-24, (54/2*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108-18, 1, 35)
				v.drawFill(320-132, 200-23, (54/2*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108-18, 1, 37)
			else
				v.drawFill(320-132, 200-25, (108*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108, 1, 55)
				v.drawFill(320-132, 200-24, (108*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108, 1, 51)
				v.drawFill(320-132, 200-23, (108*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108, 1, 53)
			end
		end
	
	end
	
	-- Tips n' Hints... not implemented yet.

end

-- ZELDA II-esque HUD

local localleveltime = 0

speccyCustomHud[#speccyCustomHud+1] = function(v, p)

	if (leveltime < 1) or (p.playerstate == PST_REBORN) then
		localleveltime = 0
	end

	if localleveltime < 2*TICRATE then
		v.drawFill(0, 0, 320, 200, 31)
		local icon = v.getSprite2Patch(p.mo.skin, SPR2_LIFE, p.powers[pw_super], 0, 0, 0)
		v.draw(146, 106, icon, nil, v.getColormap(p.mo.skin, p.mo.color))
		v.draw(156, 102, v.cachePatch("STLIVEX"), nil)
		v.drawString(164, 100, tostring(p.lives), nil)
		localleveltime = $ + 1
	end
	
	-- Black Bar for that nice feel.
	
	v.drawFill(0, 0, 320, 24, 31)

	-- Stats first, put where the Magic and Levels would be in Zelda II.

	local statsx = 52
	local statsy = 2
	
	v.drawString(statsx, statsy, "Level "+p.speccy.level, nil, "thin-center")                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  

	-- HP Bar.
	
	local hpbarx = 102
	local hpbary = 6
	
	v.drawFill(hpbarx, hpbary, 12, 12, 150)
	v.drawString(hpbarx+6, hpbary+2, "L", nil, "center")
	v.drawFill(hpbarx+12, hpbary, 98, 12, 0)
	v.drawFill(hpbarx+12, hpbary+2, 96, 8, 31)
	v.drawFill(hpbarx+12, hpbary+2, (96*p.speccy.hp/p.speccy.maxhp*96)/96, 8, 35)
	for i=1,8 do
		v.drawFill(hpbarx+12+(i-1)*12, hpbary, 2, 12, 0)
	end
	
	-- NEXT text for EXP reasons.
	
	local paddedexp = tostring(p.speccy.exp)
	local paddedexpreq = tostring(p.speccy.expreq)
	 
	for i=1, 5 do
		if string.len(paddedexp) < i then
			paddedexp = "0" .. paddedexp
		end
		if string.len(paddedexpreq) < i then
			paddedexpreq = "0" .. paddedexpreq
		end
	end
	 
	local expx = 320 - 52
	local expy = 2
	
	v.drawString(expx, expy, "      NEXT", nil, "center")   
	v.drawString(expx, expy+10, paddedexp .. "/" .. paddedexpreq, nil, "center")

end

-- PSO HUD, completely based off of the PSO ver 2 HUD from the Dreamcast release.

speccyCustomHud[#speccyCustomHud+1] = function(v, p)
	
	-- The main HUD overlay, we'll put stuff on top of it.
	
	v.draw(12, 16, v.cachePatch("PSOSPEC"), nil)
	
	-- An odd place for it, but lets put our lives where your MAG charges would be.
	
	v.drawString(39, 24, p.lives, nil, "thin")
	
	-- Our health display, contains number value, and bar.
	
	v.drawString(57, 20, "HP "..tostring(p.speccy.hp).."/"..tostring(p.speccy.maxhp), nil, "thin")
	v.drawFill(58, 27, 56, 4, 14)
	v.drawFill(58, 27, (56*p.speccy.hp/p.speccy.maxhp*56)/56, 4, 114)
	v.drawFill(59, 28, (54*p.speccy.hp/p.speccy.maxhp*54)/54, 2, 112)
	
	-- Lets replace the TP with EXP hmm?
	
	v.drawString(51, 34, "EXP "..tostring(p.speccy.exp).."/"..tostring(p.speccy.expreq), nil, "thin")
	v.drawFill(52, 41, 56, 4, 14)
	v.drawFill(52, 41, (56*p.speccy.exp/p.speccy.expreq*56)/56, 4, 135)
	v.drawFill(53, 42, (54*p.speccy.exp/p.speccy.expreq*54)/54, 2, 134)
	
	-- The player's level.
	
	v.drawString(22, 48, "Lv", nil, "thin")
	v.drawString(51, 48, p.speccy.level, nil, "thin-right")
	
	-- The player's name in the bottom right.
	
	v.drawString(56, 50, p.name, V_YELLOWMAP, "thin")
	
end

local speccy_hud = 1

COM_AddCommand("speccy_hud", function(p, arg)
	if tonumber(arg) ~= nil then
		speccy_hud = tonumber(arg)
	end
end, COM_LOCAL)

hud.add(function(v,p)
	if p.mo.skin ~= "speccy" or (not p.speccy) then
		return
	end
	
	if G_IsSpecialStage(gamemap) then return end
	
	hud.disable("score")
	hud.disable("time")
	hud.disable("rings")
	hud.disable("lives")

	speccyCustomHud[speccy_hud](v, p)
end, "game")

addHook("PlayerSpawn", function(p)
	hud.enable("score")
	hud.enable("time")
	hud.enable("rings")
	hud.enable("lives")
end)

hud.add(function(v,p)
	if G_IsSpecialStage(gamemap) then return end

	if skinchanged then
		hud.enable("score")
		hud.enable("time")
		hud.enable("rings")
		hud.enable("lives")
		skinchanged = false
	end
end, "game")