if srb2p then return end

-- Kirby Support... I don't really like Kirbo.

if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end

kirbyabilitytable["speccy"] = 10

-- Metroid Vanguard Support

freeslot( -- Another Freeslot... ugh. This one is strictly for Metroid Vanguard stuff.
	"MT_METROID", -- Standard Metroid, drains Speccy's HP.
	"MT_METROIDBOSS", -- Omega Metroid, the first custom boss in Metroid Vanguard.
	"MT_METROIDPART", -- Omega Metroid's parts.
	"MT_PZBOSS", -- Dark Samus, the second custom boss in Metroid Vanguard.
	"MT_PZWAVEHOMER", -- I don't know what this is.
	"MT_PZBARRIER", -- I don't know what this is either.
	"MT_METROIDSLASH" -- Slash attack from Omega Metroid.
)

addHook("PlayerThink", function(p) 
	
	-- Maybe this'll help...?
	
	if skins["samus"] == nil then return end
	
	-- Boss tables.
	
	-- Two Omega Metroid based things to prevent it from showing BOSS.
	
	adventureBossTable[MT_METROIDPART] = {"Omega Metroid", 50, 550}
	adventureBossTable[MT_METROIDBOSS] = {"Omega Metroid", 50, 0}
	
	-- Dark Samus.
	
	adventureBossTable[MT_PZBOSS] = {"Dark Samus", 75, 850}
	
	-- Inflictors
	
	-- Anything Omega Metroid related.
	
	adventureInfTable[MT_METROIDSLASH] = 50
	
	-- Dark Samus' stuff?
	
	adventureInfTable[MT_PZWAVEHOMER] = 60
	adventureInfTable[MT_PZBARRIER] = 75
	
	-- Samus / Dark Samus' projectiles.
	
	adventureInfTable[MT_PBSHOT] = 10 -- Power Beam Shot
	adventureInfTable[MT_PBCHARGESHOT] = 25 -- Charged Power Beam Shot
	adventureInfTable[MT_SAMMISSILE] = 30 -- Missile
	adventureInfTable[MT_SAMSUPERMISSILE] = 30 -- Super Missile
	adventureInfTable[MT_SAMMORPHBOMB] = 10 -- Morph Ball Bomb
	adventureInfTable[MT_SAMPOWERBOMB] = 25 -- Morph Ball Power Bomb
	adventureInfTable[MT_SPSHOT] = 15 -- Spazer Beam Shot
	adventureInfTable[MT_SPCHARGESHOT] = 30 -- Charged Spazer Beam Shot
	adventureInfTable[MT_WVSHOT] = 12 -- Wave Beam Shot
	adventureInfTable[MT_WVCHARGESHOT] = 27 -- Charged Wave Beam Shot
	adventureInfTable[MT_ICSHOT] = 5 -- Ice Beam Shot
	adventureInfTable[MT_ICCHARGESHOT] = 20 -- Charged Ice Beam Shot
	adventureInfTable[MT_PLSHOT] = 25 -- Plazma Beam Shot
	adventureInfTable[MT_PLCHARGESHOT] = 50 -- Charged Plazma Beam Shot
	adventureInfTable[MT_HBSHOT] = 150 -- Hyper Beam Shot... scary!	
	
	-- Now for the scariest of all, BEAM COMBOS!!!
	
	adventureInfTable[MT_SPCHARGECOMBO] = 75
	adventureInfTable[MT_ICCHARGECOMBO] = 65
	
end)

-- Super Brak.

addHook("MobjThinker", function(brak)
	if brak.superbrak then
		adventureBossTable[MT_CYBRAKDEMON] = {"Super B. Eggman", 375, 2500}
	else
		for p in players.iterate do
		
			if skins["samus"] == nil then continue end
			if not p.speccy then continue end
			if not (p.speccy.level >= 200) then continue end
			if not p.speccy.shades then continue end
		
			if leveltime < 5 then
				brak.superbraktransform = 1
				if (gamemap == 27)
					for sector in sectors.iterate
						if sector.floorheight == 608*FRACUNIT
						sector.floorheight = 512*FRACUNIT
						end
						if (sector == sectors[3] or sector == sectors[79] or sector == sectors[8]) //Most efficient method.
							if (sector == sectors[8])
							sector.ceilingheight = 480*FRACUNIT
							end
							sector.floorheight = 480*FRACUNIT
							sector.floorpic = "ERZRCKF1"
							sector.special = 0
							if sector == sectors[8]
							sector.lightlevel = 142
							else
							sector.lightlevel = 192
							end
						end
						if sector.special == 18
						sector.special = 16
						end
					end
				end
			end
		end
		adventureBossTable[MT_CYBRAKDEMON] = {"Black Eggman", 100, 1000}
	end
end, MT_CYBRAKDEMON)
